BetterExtraActionBarDB = BetterExtraActionBarDB or {}

--decouple from MainMenuBar
ExtraActionBarFrame:SetParent(UIParent)
ExtraActionBarFrame.SetParent = function() end ---noooo bt, noooo
ExtraActionBarFrame:SetMovable(true)

--Don't manage the frame for me, thanks, and don't adjust other frames to account for it
UIPARENT_MANAGED_FRAME_POSITIONS["ExtraActionBarFrame"] = nil
for k, v in next, UIPARENT_MANAGED_FRAME_POSITIONS do
	v.extraActionBarFrame = nil
end

local locked = true
local moving = nil

local overlay = CreateFrame("Frame", nil, ExtraActionBarFrame)
overlay:SetAllPoints()

overlay:EnableMouse()
overlay:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not locked then
		local frame = self:GetParent()
		frame:ClearAllPoints()
		frame:StartMoving()
		moving = true
	end
end)

overlay:SetScript("OnMouseUp", function(self, button)
	if button == "RightButton" then
		local frame = self:GetParent()
		locked = not locked
		if locked then
			frame.button.style:SetDesaturated(false)
			frame:EnableMouseWheel(false)
		else
			frame.button.style:SetDesaturated(true)
			frame:EnableMouseWheel(true)
		end

	elseif button == "MiddleButton" then
		if not locked then
			self:GetParent():SetScale(1)
			BetterExtraActionBarDB.scale = nil
		end

	elseif moving then
		moving = nil
		local frame = self:GetParent()
		frame:StopMovingOrSizing()
		frame:SetUserPlaced(false)

		local point, _, _, x, y = frame:GetPoint(1)
		BetterExtraActionBarDB.point = point
		BetterExtraActionBarDB.x = x
		BetterExtraActionBarDB.y = y
	end
end)

overlay:SetScript("OnMouseWheel", function(self, delta)
	local frame = self:GetParent()
	local scale = frame:GetScale() + (0.1 * delta)
	frame:SetScale(scale)
	BetterExtraActionBarDB.scale = scale
end)

local function onShow(self)
	local frame = self:GetParent()
	local w, h = frame.button.style:GetSize()
	frame:SetWidth(w) --expand the frame to the width of the displayed texture

	if BetterExtraActionBarDB.point then
		frame:ClearAllPoints()
		frame:SetPoint(BetterExtraActionBarDB.point, BetterExtraActionBarDB.x, BetterExtraActionBarDB.y)
	--else --default placement?
		--self:GetParent():SetPoint("BOTTOM", MainMenuBar, "BOTTOM", 0, 160)
	end

	if BetterExtraActionBarDB.scale then
		frame:SetScale(BetterExtraActionBarDB.scale)
	end
end
overlay:SetScript("OnShow", onShow)

--ExtraActionBar_OnLoad shows the frame before we get to it
overlay:SetScript("OnEvent", function(self)
	if self:GetParent():IsShown() then
		onShow(self)
	end
end)
overlay:RegisterEvent("PLAYER_ENTERING_WORLD")

_G["SLASH_BETTEREXTRABUTTONBAR1"] = "/beab"
_G.SlashCmdList["BETTEREXTRABUTTONBAR"] = function(input)
	if input == "reset" then
		--in case the frame is under the ui or offscreen
		wipe(BetterExtraActionBarDB)
		ExtraActionBarFrame:ClearAllPoints()
		ExtraActionBarFrame:SetPoint("CENTER")
	elseif input == "toggle" then
		--show/hide the frame
		local frame = ExtraActionBarFrame
		if HasExtraActionBar() and frame:IsShown() then
			--don't mess with it if its up for a fight
			return
		elseif frame:IsShown() then
			frame.intro:Stop()
			frame.outro:Play()
		else
			frame.button:Show()
			frame:Show()
			frame.outro:Stop()
			frame.intro:Play()
		end
	end
end
